--****************************************************************************
-- Software: SCP CLASS
-- Version:  0.1
-- Date:     2005/12/26
-- Author:   Valentin Schmidt
-- Contact:  fluxus@freenet.de
-- License:  Freeware
--
-- Requirements/Dependencies: 
-- o Shell Xtra (http://dasdeck.de/staff/valentin/xtras/shell/)
-- o PuTTY Secure Copy client (pscp.exe, http://www.chiark.greenend.org.uk/~sgtatham/putty/download.html)
--
--
-- USAGE:
-- scp = script("SCP").new(the moviepath & "xtras\pscp.x32", ["host":"localhost" ,"user":"admin", "pass":"secret"])
-- put scp.scp_download("foo/foo.zip", "../bar.zip", "sftp")
-- put scp.scp_upload("../bar.zip", "foo/foo.zip", "sftp")
-- scp = 0
--
--
-- PuTTY Secure Copy client
-- Release 0.57
-- Usage: pscp [options] [user@]host:source target
--        pscp [options] source [source...] [user@]host:target
--        pscp [options] -ls [user@]host:filespec
-- Options:
--  -p        preserve file attributes
--  -q        quiet, don't show statistics
--  -r        copy directories recursively
--  -v        show verbose messages
--  -load sessname  Load settings from saved session
--  -P port   connect to specified port
--  -l user   connect with specified username
--  -pw passw login with specified password
--  -1 -2     force use of particular SSH protocol version
--  -C        enable compression
--  -i key    private key file for authentication
--  -batch    disable all interactive prompts
--  -unsafe   allow server-side wildcards (DANGEROUS)
--  -V        print version information
--  -sftp     force use of SFTP protocol
--  -scp      force use of SCP protocol
--****************************************************************************

property pPscPath
property pHost 
property pUser
property pPass

----------------------------------------
-- 
----------------------------------------
on new (me, pscPath, hostProps)
  if pscPath contains SPACE and not (pscPath starts QUOTE) then pscPath = QUOTE&pscPath&QUOTE
  pPscPath = pscPath
  pHost = hostProps["host"]
  pUser = hostProps["user"]
  pPass = hostProps["pass"]
  return me
end

----------------------------------------
-- remoteFile, localFile: either absolute pathes, or relative to moviepath
-- protocol: optional, can be "scp" or "sftp"
----------------------------------------
on scp_download (me, remoteFile, localFile, protocol)
  if voidP(protocol) then protocol=""
  else protocol = " -"&protocol
  if localFile contains SPACE and not (localFile starts QUOTE) then localFile = QUOTE&localFile&QUOTE
  cmd = pPscPath & protocol && "-batch -pw" && pPass && pUser&"@"&pHost&":"&remoteFile && localFile && "2>&1"
  put cmd
  shell_setcurrentdir(the moviepath)
  ret = shell_cmd(cmd, RETURN, 30) -- 30 sec timeout!
  
  return [#status:(ret contains "100%"), #output: ret]
end

----------------------------------------
-- remoteFile, localFile: either absolute pathes, or relative to moviepath
-- protocol: optional, can be "scp" or "sftp"
----------------------------------------
on scp_upload (me, localFile, remoteFile, protocol)
  if voidP(protocol) then protocol=""
  else protocol = " -"&protocol
  if localFile contains SPACE and not (localFile starts QUOTE) then localFile = QUOTE&localFile&QUOTE
  cmd = pPscPath & protocol && "-batch -pw" && pPass && localFile && pUser&"@"&pHost&":"&remoteFile && "2>&1"
  shell_setcurrentdir(the moviepath)
  ret = shell_cmd(cmd, RETURN, 30) -- 30 sec timeout!
  
  return [#status:(ret contains "100%"), #output: ret]
end
